﻿using System;
using System.Collections;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BullhornPartnerApi;

namespace PartnerSessionExample
{
    class PartnerSessionExample
    {
        static void Main(string[] args)
        {

            demonstrateGetPartnerSession();
            Console.WriteLine("\n\n\n");
            demonstrateValidatingUrl();
            Console.ReadLine();
            
        }

        public static void demonstrateGetPartnerSession()
        {
            
            // Update these values with those from your sandbox account
            int apiUserId = #; // The ID of the Bullhorn user account you are logging in as
            int apiCorporationId = ###; // the ID of the corporation account you are logging into
            String apiKey = "XXXXXXXX-XXXX-XXXX-XXXXXXXXXXXXXXXX"; // The API key provided to you by Bullhorn
            String sharedSecret = "sharedSecret"; // This must be set up with your API key

            ApiService service = new ApiService();
            BullhornOauth bhOauth = new BullhornOauth(service);
        
            partnerSessionRequest partnerSessionRequest = new partnerSessionRequest();
            partnerSessionRequest = bhOauth.generatePartnerSessionRequest(apiKey, sharedSecret, apiUserId, apiCorporationId);
            apiStartSessionResult startSessionResult= service.startPartnerSession(partnerSessionRequest);           
            Console.Write("Your session key is: " + startSessionResult.session);      

        }

        /// <summary>
        /// Demonstrate validating Oauth generated URL
        /// </summary>
        public static void demonstrateValidatingUrl()
        {
            // Update these values with those from your sandbox account
            // The full URL with which your custom tab or component is invoked.
            String encodedUrl = "http://URLConfiguredForTabOrComponent.org?EntityType=Candidate&EntityID=5063260&UserID=5061055&CorporationID=44&PrivateLabelID=50¤tBullhornUrl=http://localhost:8500/BullhornStaffing/UserProfile.cfm?BH%5F%5F%5FENCR%3DTRUE%26NOLOGO%3DTRUE%26PROFILETYPE%3DCandidate%26USERRESULTSUUID%3D9F4F54EB%252D4061%252D8690%252DB62823B8B06BDF38%26userID%3D5063260%26view%3DCustom%2520Tab%25201%26SectionID%3D128&timestamp=1305211798&nonce=1812714867163749&authCode=DPkjIYYsxh0AY+fujOomOi1VafM="; 
            String apiKey = "XXXXXXXX-XXXX-XXXX-XXXXXXXXXXXXXXXX"; // The API key provided to you by Bullhorn
            String sharedSecret = "sharedSecret"; // This must be set up with your API key
             
            ApiService service = new ApiService();
            BullhornOauth bhOauth = new BullhornOauth(service);
           
            bool isValid = bhOauth.validateURLRequest(apiKey, sharedSecret, encodedUrl);
            Console.WriteLine("Encoded url validity = " + isValid);            
        }
    }
}
